/**
 *    author:  [itmo] enot.1.10
 *    created: 04.03.2017 12:21:05       
**/
#define __USE_MINGW_ANSI_STDIO 0
#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define forn(i, n) for(int i = 0 ; (i) < (n) ; ++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__),fflush(stderr)
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(),a.end()
#define pw(x) (1LL<<(x))

using namespace std;

typedef long long ll;
typedef double dbl;
typedef vector<int> vi;
typedef pair<int, int> pi;

const int inf = 1.01e9;
const dbl eps = 1e-9;

/* --- main part --- */

struct T
{
    int a[3][3];
    T()
    {
        memset(a, 0, sizeof a);
    }
    inline int* operator [] (int x)
    {
        return a[x];
    }
};

const int N = 55;

inline ll code(T a)
{
    ll res = 0;
    forn(i, 3) forn(j, 3) res = (res << 6) + a[i][j];
    return res;
}

inline T decode(ll h)
{
    T res;
    for (int i = 2; i >= 0; --i) for (int j = 2; j >= 0; --j)
    {
        res[i][j] = h & 63;
        h >>= 6;
    }
    return res;
}


int a[N];
int b[N];

const int SZ = 1e6 + 10;

ll F[SZ];
ll *f = F;
int ff = 0;
ll G[SZ];
ll *g = G;
int gg = 0;

int main()
{
    assert(freopen("buckets.in", "r", stdin));
    assert(freopen("buckets.out", "w", stdout));
    int n, q;
    scanf("%d%d", &n, &q);
    forn(i, n) scanf("%d", &a[i]);
    forn(i, n) scanf("%d", &b[i]);
    forn(i, n) a[i]--, b[i]--;
    
    T cnt;

    forn(i, n) cnt[a[i]][b[i]]++;
    
    f[ff++] = code(cnt);

    forn(_, q)
    {
        int from, to;
        scanf("%d%d", &from, &to);
        --from, --to;
        gg = 0;
        forn(ii, ff)
        {
            T c = decode(f[ii]);
            forn(i, 3) if (c[from][i] > 0)
            {
                c[from][i]--;
                c[to][i]++;
                g[gg++] = code(c);
                c[from][i]++;
                c[to][i]--;
            }
        }
        swap(f, g);
        swap(ff, gg);
        sort(f, f + ff);
        ff = unique(f, f + ff) - f;
    }
    int ok = 0;
    forn(ii, ff)
    {
        T c = decode(f[ii]);
        int s = 0;
        forn(i, 3) s += c[i][i];
        if (s == n)
        {
            ok = 1;
            break;
        }
    }
    if (ok) puts("YES");
    else puts("NO");
        
        
    #ifdef home
        eprintf("time = %d ms\n", (int)(clock() * 1000. / CLOCKS_PER_SEC));
    #endif
    return 0;
}
