/**
 *    author:  [itmo] enot.1.10
 *    created: 04.03.2017 23:50:10       
**/
#define __USE_MINGW_ANSI_STDIO 0
#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define forn(i, n) for(int i = 0 ; (i) < (n) ; ++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__),fflush(stderr)
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(),a.end()
#define pw(x) (1LL<<(x))

using namespace std;

typedef long long ll;
typedef double dbl;
typedef vector<int> vi;
typedef pair<int, int> pi;

const int inf = 1.01e9;
const dbl eps = 1e-9;

/* --- main part --- */

const int N = 1e5 + 10;

int a[N];
int s[N];

int e[N];

int main()
{
    assert(freopen("loganqueries.in", "r", stdin));
    assert(freopen("loganqueries.out", "w", stdout));
    int n, q;
    scanf("%d%d", &n, &q);
    forn(i, n) scanf("%d", &a[i]);
    forn(i, q)
    {
        int x, y;
        scanf("%d%d", &x, &y);
        --x;
        s[x]++;
        s[y]--;
    }
    int ss = 0;
    forn(i, n)
    {
        ss += s[i];
        e[i] = ss;
    }
    sort(e, e + n);
    sort(a, a + n);
    ll res = 0;
    forn(i, n) res += a[i] * (ll)e[i];
    printf("%I64d\n", res);
    #ifdef home
        eprintf("time = %d ms\n", (int)(clock() * 1000. / CLOCKS_PER_SEC));
    #endif
    return 0;
}
