#define _ijps 0
#define _CRT_SECURE_NO_DEPRECATE
#pragma comment(linker, "/STACK:667772160")
#include <iostream>
#include <cmath>
#include <vector>
#include <time.h>
#include <map>
#include <set>
#include <deque>
#include <cstdio>
#include <cstdlib>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <algorithm>
#include <string>
#include <fstream>
#include <assert.h> 
#include <list>
#include <cstring>
#include <queue>
using namespace std;

#define name "strangestring"
typedef unsigned long long ull;
typedef long long ll;
#define mk make_pair
//#define forn(i, n) for(int i = 0; i < (int)n; i++)
//#define fornn(i, q, n) for(ll i = (ll)q; i < (ll)n; i++)
#define times clock() * 1.0 / CLOCKS_PER_SEC


struct __isoff {
	__isoff() {
		if (_ijps)
			freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);//, freopen("test.txt", "w", stderr);
		else freopen(name".in", "r", stdin), freopen(name".out", "w", stdout);
		//ios_base::sync_with_stdio(0);
		//srand(time(0));
		srand('C' + 'T' + 'A' + 'C' + 'Y' + 'M' + 'B' + 'A');
	}
	~__isoff() {
		//if(_ijps) cout<<times<<'\n';
	}
} __osafwf;
const ull p1 = 131;
const ull p2 = 129;
const double eps = 1e-8;
const double pi = acos(-1.0);

const int infi = 1e9 + 7;
const ll inf = 1e18 + 7;
const ll dd = 5e4 + 7;


vector<int> prefix_function(string s) {
	int n = (int)s.length();
	vector<int> pi(n);
	for (int i = 1; i < n; ++i) {
		int j = pi[i - 1];
		while (j > 0 && s[i] != s[j])
			j = pi[j - 1];
		if (s[i] == s[j])  ++j;
		pi[i] = j;
	}
	return pi;
}
vector<int> z_function(string s) {
	int n = (int)s.length();
	vector<int> z(n);
	for (int i = 1, l = 0, r = 0; i < n; ++i) {
		if (i <= r)
			z[i] = min(r - i + 1, z[i - l]);
		while (i + z[i] < n && s[z[i]] == s[i + z[i]])
			++z[i];
		if (i + z[i] - 1 > r)
			l = i, r = i + z[i] - 1;
	}
	return z;
}
long long comp(string s) {
	auto a = prefix_function(s);
	auto b = z_function(s);
	long long t = 0;
	for (int i = 0; i < s.size(); i++) {
		t += a[i] * b[i];
	}
	return t;
}

string res;
string t;
long long goal;
double GG = 0;

void dfs(int g) {
	if (t.size() > res.size() || times > GG) {
		return;
	}
	long long s = comp(t);
	int f = res.size() - t.size();
	if (s > goal) {
		return;
	}
	if (s == goal) {
		if (res.size() > t.size()) {
			res = t;
		}
		return;
	}
	for (int i = 0; i <= g; i++) {
		t.push_back('a' + i);
		dfs(g);
		t.pop_back();
	}
}

string fg() {
	GG = 1.7 + times;
	res = string(1000, 'a');
	t.clear();
	for (int i = 0; i < 20; i++) {
		dfs(i);
	}
	return res;
}

string stu() {
	string g;
	int d = 1;
	while (comp(g) < goal) {
		g.push_back('a');
		if (comp(g) > goal) {
			g.pop_back();
			g.push_back('a' + d);
		}
	}
	return g;
}

void check(string s) {
	ll S = comp(s);
	assert(S == goal);
	cout << s << '\n';
}

int main() {
	cin >> goal;
	assert(goal <= 100);
	check(stu());
}