/**
 *    author:  [itmo] enot.1.10
 *    created: 04.03.2017 12:21:05       
**/
#define __USE_MINGW_ANSI_STDIO 0
#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define forn(i, n) for(int i = 0 ; (i) < (n) ; ++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__),fflush(stderr)
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(),a.end()
#define pw(x) (1LL<<(x))

using namespace std;

typedef long long ll;
typedef double dbl;
typedef vector<int> vi;
typedef pair<int, int> pi;

const int inf = 1.01e9;
const dbl eps = 1e-9;

/* --- main part --- */

const int N = 55;

int a[N];
int b[N];

int main()
{
    assert(freopen("buckets.in", "r", stdin));
    assert(freopen("buckets.out", "w", stdout));
    int n, q;
    scanf("%d%d", &n, &q);
    forn(i, n) scanf("%d", &a[i]);
    forn(i, n) scanf("%d", &b[i]);
    forn(i, n) a[i]--, b[i]--;
    
    vector<vi> cnt(3, vi(3, 0));

    forn(i, n) cnt[a[i]][b[i]]++;
    
    vector<vector<vi>> v;
    v.pb(cnt);

    forn(_, q)
    {
        int from, to;
        scanf("%d%d", &from, &to);
        --from, --to;
        vector<vector<vi>> v2;
        for (vector<vi> c : v)
        {
            forn(i, 3) if (c[from][i] > 0)
            {
                c[from][i]--;
                c[to][i]++;
                v2.pb(c);
                c[from][i]++;
                c[to][i]--;
            }
        }
        sort(all(v2));
        v2.resize(unique(all(v2)) - v2.begin());
        v = v2;
    }
    int ok = 0;
    for (vector<vi> c : v)
    {
        int s = 0;
        forn(i, 3) s += c[i][i];
        if (s == n)
        {
            ok = 1;
            break;
        }
    }
    if (ok) puts("YES");
    else puts("NO");
        
        
    #ifdef home
        eprintf("time = %d ms\n", (int)(clock() * 1000. / CLOCKS_PER_SEC));
    #endif
    return 0;
}
