/**
 *    author:  [itmo] enot.1.10
 *    created: 04.03.2017 13:20:06       
**/
#define __USE_MINGW_ANSI_STDIO 0
#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define forn(i, n) for(int i = 0 ; (i) < (n) ; ++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__),fflush(stderr)
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(),a.end()
#define pw(x) (1LL<<(x))

using namespace std;

typedef long long ll;
typedef double dbl;
typedef vector<int> vi;
typedef pair<int, int> pi;

const int inf = 1.01e9;
const dbl eps = 1e-9;

/* --- main part --- */

const int N = 1e5 + 10;
int mx;
ll k;
    
char s[N];
int ss = 0;

int d[N];

void solve1()
{
    ll kk = k;
    ss = 0;
    char C = 'a';
    for (ll x = mx - 1; x >= 1; --x)
    {
        ll val = x * (x + 1) * (x + 2) / 6;
        if (val <= kk)
        {
            kk -= val;
            s[ss++] = C;
            C = min(C + 1, (int)'c');
            forn(_, x) s[ss++] = 'a';
            ++x;
        }
    }
    if (kk == 0 && ss <= mx)
    {
        s[ss] = 0;
        printf("%s\n", s);
        exit(0);
    }
}

int p[N];
int z[N];

void solve2()
{
    while (1)
    {
        ss = 0;
        forn(i, mx) s[ss++] = 'a' + rand() % 3;
        s[ss] = 0;

        int n = ss;

        int L = 0, R = 0;
        for (int i = 1; i < n; ++i)
        {
            z[i] = max(0, min(z[i - L], R - i));
            while (s[i + z[i]] == s[z[i]]) ++z[i];
            if (i + z[i] > R) L = i, R = i + z[i];
        }
        for (int i = 1; i < n; ++i)
        {
            p[i] = p[i - 1];
            while (p[i] > 0 && s[i] != s[p[i]]) p[i] = p[p[i] - 1];
            if (s[i] == s[p[i]]) ++p[i];
        }

        ll res = 0;
        forn(i, n) res += z[i] * (ll)p[i];
        if (res == k)
        {
            printf("%s\n", s);
            exit(0);
        }
    }
}




int main()
{
    assert(freopen("strangestring.in", "r", stdin));
    assert(freopen("strangestring.out", "w", stdout));
    scanf("%I64d%d", &k, &mx);    

    solve1();
    solve2();



    #ifdef home
        eprintf("time = %d ms\n", (int)(clock() * 1000. / CLOCKS_PER_SEC));
    #endif
    return 0;
}
