#include "testlib.h"
#include <iostream>
#include <set>
#include <vector>

using namespace std;

int main(int argc, char* argv[])
{
	registerGen(argc, argv, 1);
	int n = atoi(argv[1]);
	int m = atoi(argv[2]);

    cout << n << "\n";
	set <int> s;
	vector <pair <int, int> > v(n);
	for (int i = 0; i < n; i++)
	{
		int a = rnd.next(1, m);
		int b = rnd.next(1, m);
		if (s.count(a + b))
		{
			--i;
			continue;
		}
		v[i] = { a, b };
		s.insert({ a, b });
	}
	shuffle(v.begin(), v.end());

	for (int i = 0; i < n; i++)
	{
		cout << v[i].first << ' ' << v[i].second << "\n";
	}
	return 0;
}